summaryrefslogtreecommitdiff
path: root/src/share/common
blob: a6da309240e34bb4652e224080c7b01bef7d25d6 (plain)
  1. # -*-shell-script-*-
  2. # This should be sourced by bash (though we welcome changes to make it POSIX sh compliant)
  3. # Shared sh functions for the monkeysphere
  4. #
  5. # Written by
  6. # Jameson Rollins <jrollins@finestructure.net>
  7. # Jamie McClelland <jm@mayfirst.org>
  8. # Daniel Kahn Gillmor <dkg@fifthhorseman.net>
  9. #
  10. # Copyright 2008-2009, released under the GPL, version 3 or later
  11. # all-caps variables are meant to be user supplied (ie. from config
  12. # file) and are considered global
  13. ########################################################################
  14. ### UTILITY FUNCTIONS
  15. # output version info
  16. version() {
  17. cat "${SYSSHAREDIR}/VERSION"
  18. }
  19. # failure function. exits with code 255, unless specified otherwise.
  20. failure() {
  21. [ "$1" ] && echo "$1" >&2
  22. exit ${2:-'255'}
  23. }
  24. # write output to stderr based on specified LOG_LEVEL the first
  25. # parameter is the priority of the output, and everything else is what
  26. # is echoed to stderr. If there is nothing else, then output comes
  27. # from stdin, and is not prefaced by log prefix.
  28. log() {
  29. local priority
  30. local level
  31. local output
  32. local alllevels
  33. local found=
  34. # don't include SILENT in alllevels: it's handled separately
  35. # list in decreasing verbosity (all caps).
  36. # separate with $IFS explicitly, since we do some fancy footwork
  37. # elsewhere.
  38. alllevels="DEBUG${IFS}VERBOSE${IFS}INFO${IFS}ERROR"
  39. # translate lowers to uppers in global log level
  40. LOG_LEVEL=$(echo "$LOG_LEVEL" | tr "[:lower:]" "[:upper:]")
  41. # just go ahead and return if the log level is silent
  42. if [ "$LOG_LEVEL" = 'SILENT' ] ; then
  43. return
  44. fi
  45. for level in $alllevels ; do
  46. if [ "$LOG_LEVEL" = "$level" ] ; then
  47. found=true
  48. fi
  49. done
  50. if [ -z "$found" ] ; then
  51. # default to INFO:
  52. LOG_LEVEL=INFO
  53. fi
  54. # get priority from first parameter, translating all lower to
  55. # uppers
  56. priority=$(echo "$1" | tr "[:lower:]" "[:upper:]")
  57. shift
  58. # scan over available levels
  59. for level in $alllevels ; do
  60. # output if the log level matches, set output to true
  61. # this will output for all subsequent loops as well.
  62. if [ "$LOG_LEVEL" = "$level" ] ; then
  63. output=true
  64. fi
  65. if [ "$priority" = "$level" -a "$output" = 'true' ] ; then
  66. if [ "$1" ] ; then
  67. echo "$@"
  68. else
  69. cat
  70. fi | sed 's/^/'"${LOG_PREFIX}"'/' >&2
  71. fi
  72. done
  73. }
  74. # run command as monkeysphere user
  75. su_monkeysphere_user() {
  76. # our main goal here is to run the given command as the the
  77. # monkeysphere user, but without prompting for any sort of
  78. # authentication. If this is not possible, we should just fail.
  79. # FIXME: our current implementation is overly restrictive, because
  80. # there may be some su PAM configurations that would allow su
  81. # "$MONKEYSPHERE_USER" -c "$@" to Just Work without prompting,
  82. # allowing specific users to invoke commands which make use of
  83. # this user.
  84. # chpst (from runit) would be nice to use, but we don't want to
  85. # introduce an extra dependency just for this. This may be a
  86. # candidate for re-factoring if we switch implementation languages.
  87. case $(id -un) in
  88. # if monkeysphere user, run the command under bash
  89. "$MONKEYSPHERE_USER")
  90. bash -c "$*"
  91. ;;
  92. # if root, su command as monkeysphere user
  93. 'root')
  94. su "$MONKEYSPHERE_USER" -c "$*"
  95. ;;
  96. # otherwise, fail
  97. *)
  98. log error "non-privileged user."
  99. ;;
  100. esac
  101. }
  102. # cut out all comments(#) and blank lines from standard input
  103. meat() {
  104. grep -v -e "^[[:space:]]*#" -e '^$' "$1"
  105. }
  106. # cut a specified line from standard input
  107. cutline() {
  108. head --line="$1" "$2" | tail -1
  109. }
  110. # make a temporary directory
  111. msmktempdir() {
  112. mktemp -d ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  113. }
  114. # make a temporary file
  115. msmktempfile() {
  116. mktemp ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  117. }
  118. # this is a wrapper for doing lock functions.
  119. #
  120. # it lets us depend on either lockfile-progs (preferred) or procmail's
  121. # lockfile, and should
  122. lock() {
  123. local use_lockfileprogs=true
  124. local action="$1"
  125. local file="$2"
  126. if ! ( type lockfile-create &>/dev/null ) ; then
  127. if ! ( type lockfile &>/dev/null ); then
  128. failure "Neither lockfile-create nor lockfile are in the path!"
  129. fi
  130. use_lockfileprogs=
  131. fi
  132. case "$action" in
  133. create)
  134. if [ -n "$use_lockfileprogs" ] ; then
  135. lockfile-create "$file" || failure "unable to lock '$file'"
  136. else
  137. lockfile -r 20 "${file}.lock" || failure "unable to lock '$file'"
  138. fi
  139. log debug "lock created on '$file'."
  140. ;;
  141. touch)
  142. if [ -n "$use_lockfileprogs" ] ; then
  143. lockfile-touch --oneshot "$file"
  144. else
  145. : Nothing to do here
  146. fi
  147. log debug "lock touched on '$file'."
  148. ;;
  149. remove)
  150. if [ -n "$use_lockfileprogs" ] ; then
  151. lockfile-remove "$file"
  152. else
  153. rm -f "${file}.lock"
  154. fi
  155. log debug "lock removed on '$file'."
  156. ;;
  157. *)
  158. failure "bad argument for lock subfunction '$action'"
  159. esac
  160. }
  161. # for portability, between gnu date and BSD date.
  162. # arguments should be: number longunits format
  163. # e.g. advance_date 20 seconds +%F
  164. advance_date() {
  165. local gnutry
  166. local number="$1"
  167. local longunits="$2"
  168. local format="$3"
  169. local shortunits
  170. # try things the GNU way first
  171. if date -d "$number $longunits" "$format" &>/dev/null; then
  172. date -d "$number $longunits" "$format"
  173. else
  174. # otherwise, convert to (a limited version of) BSD date syntax:
  175. case "$longunits" in
  176. years)
  177. shortunits=y
  178. ;;
  179. months)
  180. shortunits=m
  181. ;;
  182. weeks)
  183. shortunits=w
  184. ;;
  185. days)
  186. shortunits=d
  187. ;;
  188. hours)
  189. shortunits=H
  190. ;;
  191. minutes)
  192. shortunits=M
  193. ;;
  194. seconds)
  195. shortunits=S
  196. ;;
  197. *)
  198. # this is a longshot, and will likely fail; oh well.
  199. shortunits="$longunits"
  200. esac
  201. date "-v+${number}${shortunits}" "$format"
  202. fi
  203. }
  204. # check that characters are in a string (in an AND fashion).
  205. # used for checking key capability
  206. # check_capability capability a [b...]
  207. check_capability() {
  208. local usage
  209. local capcheck
  210. usage="$1"
  211. shift 1
  212. for capcheck ; do
  213. if echo "$usage" | grep -q -v "$capcheck" ; then
  214. return 1
  215. fi
  216. done
  217. return 0
  218. }
  219. # hash of a file
  220. file_hash() {
  221. if type md5sum &>/dev/null ; then
  222. md5sum "$1"
  223. elif type md5 &>/dev/null ; then
  224. md5 "$1"
  225. else
  226. failure "Neither md5sum nor md5 are in the path!"
  227. fi
  228. }
  229. # convert escaped characters in pipeline from gpg output back into
  230. # original character
  231. # FIXME: undo all escape character translation in with-colons gpg
  232. # output
  233. gpg_unescape() {
  234. sed 's/\\x3a/:/g'
  235. }
  236. # convert nasty chars into gpg-friendly form in pipeline
  237. # FIXME: escape everything, not just colons!
  238. gpg_escape() {
  239. sed 's/:/\\x3a/g'
  240. }
  241. # prompt for GPG-formatted expiration, and emit result on stdout
  242. get_gpg_expiration() {
  243. local keyExpire
  244. keyExpire="$1"
  245. if [ -z "$keyExpire" -a "$PROMPT" != 'false' ]; then
  246. cat >&2 <<EOF
  247. Please specify how long the key should be valid.
  248. 0 = key does not expire
  249. <n> = key expires in n days
  250. <n>w = key expires in n weeks
  251. <n>m = key expires in n months
  252. <n>y = key expires in n years
  253. EOF
  254. while [ -z "$keyExpire" ] ; do
  255. printf "Key is valid for? (0) " >&2
  256. read keyExpire
  257. if ! test_gpg_expire ${keyExpire:=0} ; then
  258. echo "invalid value" >&2
  259. unset keyExpire
  260. fi
  261. done
  262. elif ! test_gpg_expire "$keyExpire" ; then
  263. failure "invalid key expiration value '$keyExpire'."
  264. fi
  265. echo "$keyExpire"
  266. }
  267. passphrase_prompt() {
  268. local prompt="$1"
  269. local fifo="$2"
  270. local PASS
  271. if [ "$DISPLAY" ] && type "${SSH_ASKPASS:-ssh-askpass}" >/dev/null 2>/dev/null; then
  272. printf 'Launching "%s"\n' "${SSH_ASKPASS:-ssh-askpass}" | log info
  273. printf '(with prompt "%s")\n' "$prompt" | log debug
  274. "${SSH_ASKPASS:-ssh-askpass}" "$prompt" > "$fifo"
  275. else
  276. read -s -p "$prompt" PASS
  277. # Uses the builtin echo, so should not put the passphrase into
  278. # the process table. I think. --dkg
  279. echo "$PASS" > "$fifo"
  280. fi
  281. }
  282. # remove all lines with specified string from specified file
  283. remove_line() {
  284. local file
  285. local lines
  286. local tempfile
  287. file="$1"
  288. shift
  289. if [ ! -e "$file" ] ; then
  290. return 1
  291. fi
  292. if (($# == 1)) ; then
  293. lines=$(grep -F "$1" "$file") || true
  294. else
  295. lines=$(grep -F "$1" "$file" | grep -F "$2") || true
  296. fi
  297. # if the string was found, remove it
  298. if [ "$lines" ] ; then
  299. log debug "removing matching key lines..."
  300. tempfile=$(mktemp "${file}.XXXXXXX") || \
  301. failure "Unable to make temp file '${file}.XXXXXXX'"
  302. grep -v -F "$lines" "$file" >"$tempfile"
  303. mv -f "$tempfile" "$file"
  304. fi
  305. }
  306. # remove all lines with MonkeySphere strings from stdin
  307. remove_monkeysphere_lines() {
  308. egrep -v ' MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2} '
  309. }
  310. # translate ssh-style path variables %h and %u
  311. translate_ssh_variables() {
  312. local uname
  313. local home
  314. uname="$1"
  315. path="$2"
  316. # get the user's home directory
  317. userHome=$(get_homedir "$uname")
  318. # translate '%u' to user name
  319. path=${path/\%u/"$uname"}
  320. # translate '%h' to user home directory
  321. path=${path/\%h/"$userHome"}
  322. echo "$path"
  323. }
  324. # test that a string to conforms to GPG's expiration format
  325. test_gpg_expire() {
  326. echo "$1" | egrep -q "^[0-9]+[mwy]?$"
  327. }
  328. # touch a key file if it doesn't exist, including creating needed
  329. # directories with correct permissions
  330. touch_key_file_or_fail() {
  331. local keyFile="$1"
  332. if [ ! -f "$keyFile" ]; then
  333. # make sure to create files and directories with the
  334. # appropriate write bits turned off:
  335. newUmask=$(printf "%04o" $(( 0$(umask) | 0022 )) )
  336. [ -d $(dirname "$keyFile") ] \
  337. || (umask "$newUmask" && mkdir -p -m 0700 $(dirname "$keyFile") ) \
  338. || failure "Could not create path to $keyFile"
  339. # make sure to create this file with the appropriate bits turned off:
  340. (umask "$newUmask" && touch "$keyFile") \
  341. || failure "Unable to create $keyFile"
  342. fi
  343. }
  344. # check that a file is properly owned, and that all it's parent
  345. # directories are not group/other writable
  346. check_key_file_permissions() {
  347. local uname
  348. local path
  349. uname="$1"
  350. path="$2"
  351. if [ "$STRICT_MODES" = 'false' ] ; then
  352. log debug "skipping path permission check for '$path' because STRICT_MODES is false..."
  353. return 0
  354. fi
  355. log debug "checking path permission '$path'..."
  356. "${SYSSHAREDIR}/checkperms" "$uname" "$path"
  357. }
  358. # return a list of all users on the system
  359. list_users() {
  360. if type getent &>/dev/null ; then
  361. # for linux and FreeBSD systems
  362. getent passwd | cut -d: -f1
  363. elif type dscl &>/dev/null ; then
  364. # for Darwin systems
  365. dscl localhost -list /Search/Users
  366. else
  367. failure "Neither getent or dscl is in the path! Could not determine list of users."
  368. fi
  369. }
  370. # take one argument, a service name. in response, print a series of
  371. # lines, each with a unique numeric port number that might be
  372. # associated with that service name. (e.g. in: "https", out: "443")
  373. # if nothing is found, print nothing, and return 0.
  374. #
  375. # return 1 if there was an error in the search somehow
  376. get_port_for_service() {
  377. [[ "$1" =~ ^[a-z0-9]([a-z0-9-]*[a-z0-9])?$ ]] || \
  378. failure $(printf "This is not a valid service name: '%s'" "$1")
  379. if type getent &>/dev/null ; then
  380. # for linux and FreeBSD systems (getent returns 2 if not found, 0 on success, 1 or 3 on various failures)
  381. (getent services "$service" || if [ "$?" -eq 2 ] ; then true ; else false; fi) | awk '{ print $2 }' | cut -f1 -d/ | sort -u
  382. elif [ -r /etc/services ] ; then
  383. # fall back to /etc/services for systems that don't have getent (MacOS?)
  384. # FIXME: doesn't handle aliases like "null" (or "http"?), which don't show up at the beginning of the line.
  385. awk $(printf '/^%s[[:space:]]/{ print $2 }' "$1") /etc/services | cut -f1 -d/ | sort -u
  386. else
  387. return 1
  388. fi
  389. }
  390. # return the path to the home directory of a user
  391. get_homedir() {
  392. local uname=${1:-`whoami`}
  393. eval "echo ~${uname}"
  394. }
  395. # return the primary group of a user
  396. get_primary_group() {
  397. local uname=${1:-`whoami`}
  398. groups "$uname" | sed 's/^..* : //' | awk '{ print $1 }'
  399. }
  400. ### CONVERSION UTILITIES
  401. # output the ssh key for a given key ID
  402. gpg2ssh() {
  403. local keyID
  404. keyID="$1"
  405. gpg --export --no-armor "$keyID" | openpgp2ssh "$keyID" 2>/dev/null
  406. }
  407. # output known_hosts line from ssh key
  408. ssh2known_hosts() {
  409. local host
  410. local port
  411. local key
  412. # FIXME this does not properly deal with IPv6 hosts using the
  413. # standard port (because it's unclear whether their final
  414. # colon-delimited address section is a port number or an address
  415. # string)
  416. host=${1%:*}
  417. port=${1##*:}
  418. key="$2"
  419. # specify the host and port properly for new ssh known_hosts
  420. # format
  421. if [ "$port" != "$host" ] ; then
  422. host="[${host}]:${port}"
  423. fi
  424. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  425. }
  426. # output authorized_keys line from ssh key
  427. ssh2authorized_keys() {
  428. local userID="$1"
  429. local key="$2"
  430. if [[ "$AUTHORIZED_KEYS_OPTIONS" ]]; then
  431. printf "%s %s MonkeySphere%s %s\n" "$AUTHORIZED_KEYS_OPTIONS" "$key" "$DATE" "$userID"
  432. else
  433. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  434. fi
  435. }
  436. # convert key from gpg to ssh known_hosts format
  437. gpg2known_hosts() {
  438. local host
  439. local keyID
  440. local key
  441. host="$1"
  442. keyID="$2"
  443. key=$(gpg2ssh "$keyID")
  444. # NOTE: it seems that ssh-keygen -R removes all comment fields from
  445. # all lines in the known_hosts file. why?
  446. # NOTE: just in case, the COMMENT can be matched with the
  447. # following regexp:
  448. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  449. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  450. }
  451. # convert key from gpg to ssh authorized_keys format
  452. gpg2authorized_keys() {
  453. local userID
  454. local keyID
  455. local key
  456. userID="$1"
  457. keyID="$2"
  458. key=$(gpg2ssh "$keyID")
  459. # NOTE: just in case, the COMMENT can be matched with the
  460. # following regexp:
  461. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  462. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  463. }
  464. ### GPG UTILITIES
  465. # script to determine if gpg version is equal to or greater than specified version
  466. is_gpg_version_greater_equal() {
  467. local gpgVersion=$(gpg --version | head -1 | awk '{ print $3 }')
  468. local latest=$(printf '%s\n%s\n' "$1" "$gpgVersion" \
  469. | tr '.' ' ' | sort -g -k1 -k2 -k3 \
  470. | tail -1 | tr ' ' '.')
  471. [[ "$gpgVersion" == "$latest" ]]
  472. }
  473. # retrieve all keys with given user id from keyserver
  474. # FIXME: need to figure out how to retrieve all matching keys
  475. # (not just first N (5 in this case))
  476. gpg_fetch_userid() {
  477. local returnCode=0
  478. local userID
  479. if [ "$CHECK_KEYSERVER" != 'true' ] ; then
  480. return 0
  481. fi
  482. userID="$1"
  483. log verbose " checking keyserver $KEYSERVER... "
  484. echo 1,2,3,4,5 | \
  485. gpg --quiet --batch --with-colons \
  486. --command-fd 0 --keyserver "$KEYSERVER" \
  487. --search ="$userID" &>/dev/null
  488. returnCode="$?"
  489. if [ "$returnCode" != 0 ] ; then
  490. log error "Failure ($returnCode) searching keyserver $KEYSERVER for user id '$userID'"
  491. fi
  492. return "$returnCode"
  493. }
  494. ########################################################################
  495. ### PROCESSING FUNCTIONS
  496. # userid and key policy checking
  497. # the following checks policy on the returned keys
  498. # - checks that full key has appropriate valididy (u|f)
  499. # - checks key has specified capability (REQUIRED_KEY_CAPABILITY)
  500. # - checks that requested user ID has appropriate validity
  501. # (see /usr/share/doc/gnupg/DETAILS.gz)
  502. # output is one line for every found key, in the following format:
  503. #
  504. # flag:sshKey
  505. #
  506. # "flag" is an acceptability flag, 0 = ok, 1 = bad
  507. # "sshKey" is the relevant OpenPGP key, in the form accepted by OpenSSH
  508. #
  509. # all log output must go to stderr, as stdout is used to pass the
  510. # flag:sshKey to the calling function.
  511. process_user_id() {
  512. local returnCode=0
  513. local userID="$1"
  514. local requiredCapability
  515. local requiredPubCapability
  516. local gpgOut
  517. local type
  518. local validity
  519. local keyid
  520. local uidfpr
  521. local usage
  522. local keyOK
  523. local uidOK
  524. local lastKey
  525. local lastKeyOK
  526. local fingerprint
  527. # set the required key capability based on the mode
  528. requiredCapability=${REQUIRED_KEY_CAPABILITY:="a"}
  529. requiredPubCapability=$(echo "$requiredCapability" | tr "[:lower:]" "[:upper:]")
  530. # fetch the user ID if necessary/requested
  531. gpg_fetch_userid "$userID"
  532. # output gpg info for (exact) userid and store
  533. gpgOut=$(gpg --list-key --fixed-list-mode --with-colon \
  534. --with-fingerprint --with-fingerprint \
  535. ="$userID" 2>/dev/null) || returnCode="$?"
  536. # if the gpg query return code is not 0, return 1
  537. if [ "$returnCode" -ne 0 ] ; then
  538. log verbose " no primary keys found."
  539. return 1
  540. fi
  541. # loop over all lines in the gpg output and process.
  542. echo "$gpgOut" | cut -d: -f1,2,5,10,12 | \
  543. while IFS=: read -r type validity keyid uidfpr usage ; do
  544. # process based on record type
  545. case $type in
  546. 'pub') # primary keys
  547. # new key, wipe the slate
  548. keyOK=
  549. uidOK=
  550. lastKey=pub
  551. lastKeyOK=
  552. fingerprint=
  553. log verbose " primary key found: $keyid"
  554. # if overall key is not valid, skip
  555. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  556. log debug " - unacceptable primary key validity ($validity)."
  557. continue
  558. fi
  559. # if overall key is disabled, skip
  560. if check_capability "$usage" 'D' ; then
  561. log debug " - key disabled."
  562. continue
  563. fi
  564. # if overall key capability is not ok, skip
  565. if ! check_capability "$usage" $requiredPubCapability ; then
  566. log debug " - unacceptable primary key capability ($usage)."
  567. continue
  568. fi
  569. # mark overall key as ok
  570. keyOK=true
  571. # mark primary key as ok if capability is ok
  572. if check_capability "$usage" $requiredCapability ; then
  573. lastKeyOK=true
  574. fi
  575. ;;
  576. 'uid') # user ids
  577. if [ "$lastKey" != pub ] ; then
  578. log verbose " ! got a user ID after a sub key?! user IDs should only follow primary keys!"
  579. continue
  580. fi
  581. # if an acceptable user ID was already found, skip
  582. if [ "$uidOK" = 'true' ] ; then
  583. continue
  584. fi
  585. # if the user ID does matches...
  586. if [ "$(echo "$uidfpr" | gpg_unescape)" = "$userID" ] ; then
  587. # and the user ID validity is ok
  588. if [ "$validity" = 'u' -o "$validity" = 'f' ] ; then
  589. # mark user ID acceptable
  590. uidOK=true
  591. else
  592. log debug " - unacceptable user ID validity ($validity)."
  593. fi
  594. else
  595. continue
  596. fi
  597. # output a line for the primary key
  598. # 0 = ok, 1 = bad
  599. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  600. log verbose " * acceptable primary key."
  601. if [ -z "$sshKey" ] ; then
  602. log verbose " ! primary key could not be translated (not RSA?)."
  603. else
  604. echo "0:${sshKey}"
  605. fi
  606. else
  607. log debug " - unacceptable primary key."
  608. if [ -z "$sshKey" ] ; then
  609. log debug " ! primary key could not be translated (not RSA?)."
  610. else
  611. echo "1:${sshKey}"
  612. fi
  613. fi
  614. ;;
  615. 'sub') # sub keys
  616. # unset acceptability of last key
  617. lastKey=sub
  618. lastKeyOK=
  619. fingerprint=
  620. # don't bother with sub keys if the primary key is not valid
  621. if [ "$keyOK" != true ] ; then
  622. continue
  623. fi
  624. # don't bother with sub keys if no user ID is acceptable:
  625. if [ "$uidOK" != true ] ; then
  626. continue
  627. fi
  628. # if sub key validity is not ok, skip
  629. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  630. log debug " - unacceptable sub key validity ($validity)."
  631. continue
  632. fi
  633. # if sub key capability is not ok, skip
  634. if ! check_capability "$usage" $requiredCapability ; then
  635. log debug " - unacceptable sub key capability ($usage)."
  636. continue
  637. fi
  638. # mark sub key as ok
  639. lastKeyOK=true
  640. ;;
  641. 'fpr') # key fingerprint
  642. fingerprint="$uidfpr"
  643. sshKey=$(gpg2ssh "$fingerprint")
  644. # if the last key was the pub key, skip
  645. if [ "$lastKey" = pub ] ; then
  646. continue
  647. fi
  648. # output a line for the sub key
  649. # 0 = ok, 1 = bad
  650. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  651. log verbose " * acceptable sub key."
  652. if [ -z "$sshKey" ] ; then
  653. log error " ! sub key could not be translated (not RSA?)."
  654. else
  655. echo "0:${sshKey}"
  656. fi
  657. else
  658. log debug " - unacceptable sub key."
  659. if [ -z "$sshKey" ] ; then
  660. log debug " ! sub key could not be translated (not RSA?)."
  661. else
  662. echo "1:${sshKey}"
  663. fi
  664. fi
  665. ;;
  666. esac
  667. done | sort -t: -k1 -n -r
  668. # NOTE: this last sort is important so that the "good" keys (key
  669. # flag '0') come last. This is so that they take precedence when
  670. # being processed in the key files over "bad" keys (key flag '1')
  671. }
  672. process_keys_for_file() {
  673. local keyFile="$1"
  674. local userID="$2"
  675. local host
  676. local ok
  677. local sshKey
  678. log verbose "processing: $userID"
  679. log debug "key file: $keyFile"
  680. IFS=$'\n'
  681. for line in $(process_user_id "$userID") ; do
  682. ok=${line%%:*}
  683. sshKey=${line#*:}
  684. if [ -z "$sshKey" ] ; then
  685. continue
  686. fi
  687. # remove the old host key line
  688. if [[ "$keyFile" != '-' ]] ; then
  689. case "$FILE_TYPE" in
  690. ('authorized_keys')
  691. remove_line "$keyFile" "$sshKey"
  692. ;;
  693. ('known_hosts')
  694. host=${userID#ssh://}
  695. remove_line "$keyFile" "$host" "$sshKey"
  696. ;;
  697. esac
  698. fi
  699. # if key OK, add new host line
  700. if [ "$ok" -eq '0' ] ; then
  701. case "$FILE_TYPE" in
  702. ('raw')
  703. echo "$sshKey" | log debug
  704. if [[ "$keyFile" == '-' ]] ; then
  705. echo "$sshKey"
  706. else
  707. echo "$sshKey" >>"$keyFile"
  708. fi
  709. ;;
  710. ('authorized_keys')
  711. ssh2authorized_keys "$userID" "$sshKey" | log debug
  712. if [[ "$keyFile" == '-' ]] ; then
  713. ssh2authorized_keys "$userID" "$sshKey"
  714. else
  715. ssh2authorized_keys "$userID" "$sshKey" >> "$keyFile"
  716. fi
  717. ;;
  718. ('known_hosts')
  719. host=${userID#ssh://}
  720. ssh2known_hosts "$host" "$sshKey" | log debug
  721. # hash if specified
  722. if [ "$HASH_KNOWN_HOSTS" = 'true' ] ; then
  723. if (type ssh-keygen >/dev/null) ; then
  724. # FIXME: this is really hackish cause
  725. # ssh-keygen won't hash from stdin to
  726. # stdout
  727. tmpfile=$(mktemp ${TMPDIR:-/tmp}/tmp.XXXXXXXXXX)
  728. ssh2known_hosts "$host" "$sshKey" \
  729. > "$tmpfile"
  730. ssh-keygen -H -f "$tmpfile" 2>/dev/null
  731. if [[ "$keyFile" == '-' ]] ; then
  732. cat "$tmpfile"
  733. else
  734. cat "$tmpfile" >> "$keyFile"
  735. fi
  736. rm -f "$tmpfile" "${tmpfile}.old"
  737. # FIXME: we could do this without needing
  738. # ssh-keygen. hashed known_hosts looks
  739. # like: |1|X|Y where 1 means SHA1 (nothing
  740. # else is defined in openssh sources), X
  741. # is the salt (same length as the digest
  742. # output), base64-encoded, and Y is the
  743. # digested hostname (also base64-encoded).
  744. # see hostfile.{c,h} in openssh sources.
  745. else
  746. failure "Cannot hash known_hosts as requested"
  747. fi
  748. # log if this is a new key to the known_hosts file
  749. if [ "$noKey" ] ; then
  750. log info "* new key will be added to known_hosts file."
  751. fi
  752. else
  753. if [[ "$keyFile" == '-' ]] ; then
  754. ssh2known_hosts "$host" "$sshKey"
  755. else
  756. ssh2known_hosts "$host" "$sshKey" >>"$keyFile"
  757. fi
  758. fi
  759. ;;
  760. esac
  761. fi
  762. done
  763. }
  764. # process an authorized_user_ids file on stdin for authorized_keys
  765. process_authorized_user_ids() {
  766. local authorizedKeys="$1"
  767. declare -i nline=0
  768. local line
  769. declare -a userIDs
  770. declare -a koptions
  771. # extract user IDs from authorized_user_ids file
  772. IFS=$'\n'
  773. while read line ; do
  774. case "$line" in
  775. ("#"*)
  776. continue
  777. ;;
  778. (" "*|$'\t'*)
  779. if [[ -z ${koptions[${nline}]} ]]; then
  780. koptions[${nline}]=$(echo $line | sed 's/^[ ]*//;s/[ ]$//;')
  781. else
  782. koptions[${nline}]="${koptions[${nline}]},$(echo $line | sed 's/^[ ]*//;s/[ ]$//;')"
  783. fi
  784. ;;
  785. (*)
  786. ((++nline))
  787. userIDs[${nline}]="$line"
  788. unset koptions[${nline}] || true
  789. ;;
  790. esac
  791. done
  792. for i in $(seq 1 $nline); do
  793. AUTHORIZED_KEYS_OPTIONS="${koptions[$i]}" FILE_TYPE='authorized_keys' process_keys_for_file "$authorizedKeys" "${userIDs[$i]}" || returnCode="$?"
  794. done
  795. }
  796. # takes a gpg key or keys on stdin, and outputs a list of
  797. # fingerprints, one per line:
  798. list_primary_fingerprints() {
  799. local fake=$(msmktempdir)
  800. trap "rm -rf $fake" EXIT
  801. GNUPGHOME="$fake" gpg --no-tty --quiet --import --ignore-time-conflict 2>/dev/null
  802. GNUPGHOME="$fake" gpg --with-colons --fingerprint --list-keys | \
  803. awk -F: '/^fpr:/{ print $10 }'
  804. trap - EXIT
  805. rm -rf "$fake"
  806. }
  807. # takes an OpenPGP key or set of keys on stdin, a fingerprint or other
  808. # key identifier as $1, and outputs the gpg-formatted information for
  809. # the requested keys from the material on stdin
  810. get_cert_info() {
  811. local fake=$(msmktempdir)
  812. trap "rm -rf $fake" EXIT
  813. GNUPGHOME="$fake" gpg --no-tty --quiet --import --ignore-time-conflict 2>/dev/null
  814. GNUPGHOME="$fake" gpg --with-colons --fingerprint --fixed-list-mode --list-keys "$1"
  815. trap - EXIT
  816. rm -rf "$fake"
  817. }
  818. check_cruft_file() {
  819. local loc="$1"
  820. local version="$2"
  821. if [ -e "$loc" ] ; then
  822. printf "! The file '%s' is no longer used by\n monkeysphere (as of version %s), and can be removed.\n\n" "$loc" "$version" | log info
  823. fi
  824. }
  825. check_upgrade_dir() {
  826. local loc="$1"
  827. local version="$2"
  828. if [ -d "$loc" ] ; then
  829. printf "The presence of directory '%s' indicates that you have\nnot yet completed a monkeysphere upgrade.\nYou should probably run the following script:\n %s/transitions/%s\n\n" "$loc" "$SYSSHAREDIR" "$version" | log info
  830. fi
  831. }
  832. ## look for cruft from old versions of the monkeysphere, and notice if
  833. ## upgrades have not been run:
  834. report_cruft() {
  835. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-host" 0.23
  836. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-authentication" 0.23
  837. check_cruft_file "${SYSCONFIGDIR}/gnupg-authentication.conf" 0.23
  838. check_cruft_file "${SYSCONFIGDIR}/gnupg-host.conf" 0.23
  839. local found=
  840. for foo in "${SYSDATADIR}/backup-from-"*"-transition" ; do
  841. if [ -d "$foo" ] ; then
  842. printf "! %s\n" "$foo" | log info
  843. found=true
  844. fi
  845. done
  846. if [ "$found" ] ; then
  847. printf "The directories above are backups left over from a monkeysphere transition.\nThey may contain copies of sensitive data (host keys, certifier lists), but\nthey are no longer needed by monkeysphere.\nYou may remove them at any time.\n\n" | log info
  848. fi
  849. }